<?php
declare(strict_types=1);
namespace OliverHader\ExtbaseArguments\Controller;

use OliverHader\ExtbaseArguments\Domain\Model\Model;
use TYPO3\CMS\Extbase\Annotation\Validate;
use TYPO3\CMS\Extbase\Mvc\Controller\ActionController;

class DefaultController extends ActionController
{
    public function indexAction()
    {
        $subModel = new Model();
        $subModel->setValue('sub model (index)');
        $this->forward('validate', null, null, ['subModel' => $subModel]);
    }

    /**
     * @param Model $subModel
     * @param Model $model
     */
    public function validateAction(Model $subModel, Model $model = null)
    {
        if ($model === null) {
            $model = new Model();
            $model->setValue('top model (validate)');
            $model->setModel($subModel);
        }
        $this->view->assign('model', $model);
        $this->view->assign('action', __FUNCTION__);
    }

    /**
     * @param Model $model
     * @Validate("OliverHader\ExtbaseArguments\Validation\FailingValidator", param="model")
     */
    public function finishAction(Model $model)
    {
        $this->view->assign('model', $model);
        $this->view->assign('action', __FUNCTION__);
    }

    private function createModel(string $scope): Model
    {
        $subModel = new Model();
        $subModel->setValue(sprintf('sub model (%s)', $scope));
        $model = new Model();
        $model->setValue(sprintf('top model (%s)', $scope));
        $model->setModel($subModel);
        return $model;
    }
}